const system = require("../../../system");
const ServiceBase = require("../../sve.base");
const settings = require("../../../../config/settings");

class PushBusinessService extends ServiceBase {
  constructor() {
    super("dbpush", ServiceBase.getDaoName(PushBusinessService));
    this.pushbusinessDao = system.getObject("db.dbpush.pushbusinessDao");
  }
  async opFqPushBusiness(pushBusinessSource, reqEnv, action_body) {
    var item = await this.pushbusinessDao.getItemByUappKey(action_body.app.uappKey, reqEnv);
    if (!item) {
      return system.getResult(null, "push_business item is not empty");
    }
    var body = {
      idempotentId: item.pushProductId,// 是 接入方业务产品 ID
      productId: item.sveProductId,// 是 产品 ID
      idempotentSource: item.sourceCode || "tm_1688",// 是 业务来源（ali、jd）
      idempotentSourceName: item.sourceName || "1688应用",// 是 阿里，京东

      city: action_body.city || "",// 否 所属城市
      phone: action_body.phone || "15010929366",// 是 手机号
      userId: action_body.userId || "channelUserIdtest01",// 否 用户 ID
      companyName: action_body.companyName || "",// 否 公司名称
      orderPrice: action_body.phoneaction_body.orderPrice || 899,// 是 订单金额             
      productQuantity: action_body.productQuantity || 1,// 是 产品数量
    };
    if (!body.idempotentId) {
      return system.getResult(null, "idempotentId is not empty");
    }//接入方业务产品 ID
    if (!body.idempotentSource) {
      return system.getResult(null, "idempotentSource is not empty");
    }//业务来源（ali、jdyun、1688）
    if (!body.idempotentSourceName) {
      return system.getResult(null, "idempotentSourceName is not empty");
    }//业务来源名称 京东云应用、阿里云应用、1688应用
    if (!body.phone) {
      return system.getResult(null, "phone is not empty");
    }//手机号
    if (!body.orderPrice) {
      return system.getResult(null, "orderPrice is not empty");
    }//订单金额  double
    if (!body.productId) {
      return system.getResult(null, "productId is not empty");
    }//订单金额  string
    if (!body.productQuantity) {
      return system.getResult(null, "productQuantity is not empty");
    }//产品数量  int
    // city、companyName

    var aliGateway = system.getObject("util.aliyunClient");
    var result = await aliGateway.post(item.aliAppkey, item.aliSecret, item.pushSveUrl, body);
    return result;

    // if (reqEnv == "fqdev") {
    //   aliGateway=system.getObject("util.aliyunFqDevClient");
    // }
    // else if (reqEnv == "fqProd") {
    //   aliGateway=system.getObject("util.aliyunFqProdClient");
    // }
  }
}
module.exports = PushBusinessService;
